;ASM 12lut010 autor yesma
;linux AMD64
;program ten szuka w plikach okreslonego katalogu podanej mu frazy
;./find_str_in_file "/home/yesma" "ala ma kota:)"
;--------- CUT
;#!/bin/bash
;#przykladowy make_sys			;./make_sys find_str_in_file
;file=$1
;nasm -f elf64 $file.asm -o $file.obj
;ld -s -o $file $file.obj
;rm $file.obj
;---------
%define LONG			8
%define INT_			4
%define SHORT_			2
%define PT			LONG
%define ENT_NAME		256

%define O_RDONLY		0o
%define O_NONBLOCK		4000o
%define O_DIRECTORY		200000o
%define DT_REG			8			; This is a regular file.
%define PROT_READ		0x1			; page can be read
%define MAP_PRIVATE		0x02			; Changes are private

struc stat64
	.st_dev			resb LONG		;/* urządzenie */
	.st_ino			resb LONG		;/* i-węzeł (inode) *//* File serial number
	.st_nlink		resb LONG		;/* liczba dowiązań stałych
	.st_mode		resb INT_		;/* ochrona */
	.st_uid			resb INT_
	.st_gid			resb INT_
	.pad0			resb INT_
	.st_rdev		resb LONG		;typ urządzenia jeśli urządzenie inode
	.st_size		resb LONG		;rozmiar
	.st_blksize		resb LONG		;wielkość bloku dla I/O
;	/* Number 512-byte blocks allocated. */
	.st_blocks		resb LONG		;ilość zaalokowanych bloków
	.st_atime		resb LONG		;czas ostatniego dostępu
	.st_atime_nsec		resb LONG		;unused
	.st_mtime		resb LONG		;czas ostatniej modyfikacji
	.st_mtime_nsec		resb LONG		;unused
	.st_ctime		resb LONG		;czas ostatniej zmiany
	.st_ctime_nsec		resb LONG		;unused
				resb LONG		;long int __unused[3];
				resb LONG
				resb LONG
endstruc

struc dirent64
	.d_ino		resb LONG
	.d_off		resb LONG
	.d_reclen	resb SHORT_
	.d_name		resb ENT_NAME
	.d_type		resb 6
endstruc

%macro sys_write 3
	mov rdi,%1
	mov rsi,%2
	mov rdx,%3
	mov rax,1
	syscall
%endm

%macro sys_open 2
	mov rdi,%1
	mov rsi,%2
	mov rax,2
	syscall
%endmacro

%macro sys_close 1
	mov rdi,%1
	mov rax,3
	syscall
%endmacro

%macro sys_fstat 2
	mov rdi,%1
	mov rsi,%2
	mov rax,5
	syscall
%endmacro

%macro sys_mmap	6
	mov rdi,%1
	mov rsi,%2
	mov rdx,%3
	mov r10,%4
	mov r8,%5
	mov r9,%6
	mov rax,9
	syscall
%endmacro

%macro sys_munmap 2
	mov rdi,%1
	mov rsi,%2
	mov rax,11
	syscall
%endmacro

%macro sys_exit 0
	xor rdi,rdi
	mov rax,60
	syscall
%endmacro 

%macro sys_chdir 1
	mov rdi,%1
	mov rax,80
	syscall
%endmacro

%macro sys_getdents 3
	mov rdi,%1
	mov rsi,%2
	mov rdx,%3
	mov rax,78
	syscall
%endmacro
;rsi src, rdi dst
;%1=ile razy loop %2=do jakiego znaku kopiowac ewentualnie %3=liczyc ile ma znakow np inc dx
%macro copy_compare 2-3
	push rax
	push rcx

	xor rcx,rcx
	mov cx,%1
%%load:
	lodsb
	cmp al,%2
	je %%loaded
	stosb
	%3						;np inc dx
	loop %%load
%%loaded:
	pop rcx
	pop rax
%endmacro
;rsi pt
;%1=do jakiego znaku przesunac ewentualnie %2=liczyc ile ma znakow np inc bl
%macro skeep_rsi_macro 2-3
	push rax
	push rcx

	xor rcx,rcx
	mov cx,%1
	cld
%%skeep:
	lodsb
	cmp al,%2
	je %%skeeped
	%3
	loop %%skeep
%%skeeped:
	pop rcx
	pop rax
%endmacro

%macro clear_bufb 2
	push rax
	push rcx
	
	mov rcx,%2
	mov rdi,%1
	xor al,al
	cld
	rep stosb

	pop rcx
	pop rax
%endmacro

section .data

	fold_err		db "niema takiego katalogu",0ah
	fold_err_len		equ $ - fold_err
	use			db " path sequence (to fint in files)",0ah
	use_len			equ $ - use
	err_1			db "to less arguments",0ah
	err_1_len		equ $ - err_1
	err_2			db "to much arguments",0ah
	err_2_len		equ $ - err_2

section .bss

	a_dirent		resb dirent64_size
	fd			resb LONG
	ARGC			resb LONG
	prog_name		resb PT
	prog_len		resb LONG
	folder			resb PT
	ciag			resb PT
	ciag_len		resb LONG

section .text

global _start
_start:
	push rbp
	mov rbp,rsp

	mov rax,[rbp + 8]
	mov [ARGC],rax
	mov rax,[rbp + 16]
	mov [prog_name],rax
	mov rax,[rbp + 24]
	mov [folder],rax
	mov rax,[rbp + 32]
	mov [ciag],rax
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	mov rsi,[prog_name]
	xor dx,dx
	skeep_rsi_macro ENT_NAME,0,inc dx
	mov [prog_len],dx
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	mov ax,[ARGC]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	cmp ax,1
	ja .dwa
	sys_write 1,[prog_name],[prog_len]
	sys_write 1,use,use_len
	jmp .exit
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.dwa:
	cmp ax,2
	ja .trzy
	sys_write 1,err_1,err_1_len
	jmp .exit
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.trzy:
	cmp ax,4
	jb .args_ok
	sys_write 1,err_2,err_2_len
	jmp .exit
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.args_ok:
	mov rsi,[ciag]					;ASCIIZ
	xor dx,dx
	skeep_rsi_macro 256,0,inc dx			;maksymalna dlugosc ciagu,np 256
	mov [ciag_len],dx

	sys_open [folder],O_RDONLY | O_DIRECTORY | O_NONBLOCK
	cmp rax,0
	jg .open_ok
	sys_write 1,fold_err,fold_err_len
	jmp .exit
.open_ok:
	mov [fd],rax
	sys_chdir [folder]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ LOOP
.loo:
	clear_bufb a_dirent,dirent64_size
	sys_getdents [fd],a_dirent,dirent64_size
	cmp eax,0
	ja .dal
	jmp .end
.dal:
	mov rcx,rax					;entries len
	mov rdi,a_dirent
;rdi pt dirent,rcx ents size
call read_ents
	jmp .loo
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ENDLOOP
.end:
sys_close [fd]
.exit:
	pop rbp
sys_exit
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
read_ents:
section .data
	.nl			dq 0ah
	.name_len		dq 0
section .bss
	.file			resb ENT_NAME + LONG	;1 + pad
	.fd			resb LONG
	.map_pt			resb PT			;pt obszar mapowanej pamieci
	.map_len		resb LONG		;len pliku ktory mapuje w pamieci
	.stat_			resb stat64_size
section .text

;rdi pt dirent,rcx ents size
.loop:
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	mov rsi,rdi
	add rsi,16					;dirent64 .d_ino .d_off
	xor rax,rax
	mov ax,[rsi]					;ent len .d_reclen
	add rsi,2					;.d_reclen
	add rdi,rax
push rdi
push rax
push rcx
	dec rdi						;w al pt ent type
	mov al,[rdi]
	cmp al,DT_REG
	je .czytaj
	jmp .end_type
.czytaj:
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;rsi pt file name
	mov rdi,.file
	xor dx,dx
	copy_compare ENT_NAME,0,inc dx
	mov [.name_len],dx
	xor al,al
	stosb						;ASCIIZ
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ open file
	sys_open .file,O_RDONLY
	mov [.fd],rax
	sys_fstat [.fd],.stat_
	mov rax,[.stat_ + stat64.st_size]
	cmp rax,[ciag_len]
	jae .ok
	sys_close [.fd]
	jmp .end_type
.ok:
	mov [.map_len],rax
	sys_mmap 0,[.map_len],PROT_READ,MAP_PRIVATE,[.fd],0
	mov [.map_pt],rax
	sys_close [.fd]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	mov rsi,[ciag]
	mov rdx,[ciag_len]
	mov rdi,[.map_pt]
	mov rcx,[.map_len]
call find_word_in_file
	cmp rax,1
	jne .niema
	sys_write 1,.file,[.name_len]
	sys_write 1,.nl,1
.niema:
	sys_munmap [.map_pt],[.map_len]
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.end_type:
pop rcx
pop rax
pop rdi
	sub rcx,rax					;sub od wszystkich entow len actualnego
	cmp rcx,0
	je .end
	jmp .loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.end:
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
find_word_in_file:
;rdi,[.map_pt];rcx,[.map_len];rsi ciag;rdx ciag len
.loop:
	cmp rcx,rdx
	jb .niema
	mov al,[rsi]
	cld
	repne scasb
	jne .niema
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
push rcx
push rdi
push rsi
	mov rcx,rdx
	inc cx
	dec rdi
	cld
	repe cmpsb
	cmp cx,0
	je .jest_ten
pop rsi
pop rdi
pop rcx
	jmp .nie_ten
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ;znalazlem
.jest_ten:
pop rsi
pop rdi
pop rcx
	mov rax,1
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.nie_ten:
	jmp .loop
.niema:
	xor rax,rax
ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~